//////////////////////////////////////////////////////////////////////////////////////////////////

#include <acknex.h>
#include <default.c>

//////////////////////////////////////////////////////////////////////////////////////////////////

BMAP* snow_tga = "snow.tga";
BMAP* fire_bmp = "fire.bmp";
BMAP* smoke_tga = "smoke.tga";

var temp[5];
var i;

var waterfall_group = 0;
var waterfall_group2 = 0;
var door_trigger = 0;

SOUND* sound2 = "wtrfll.ogg";
SOUND* sound3 = "fire.wav";

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

function kill_fireball(PARTICLE *p)
{
	p.lifespan = 0;	
}

function fireball_part(PARTICLE *p)
{
	p.bmap = snow_tga;
	p.lifespan = 1;
	p.event = kill_fireball;
	p.size = 4 + random(4);
	set(p,OVERLAY);
}

function kill_snow(PARTICLE *p)
{
	p.alpha -= 0.4 * time_step;
	if(p.alpha < 10)
	{
	p.lifespan = 0;	
	}	
}

function snow_part(PARTICLE *p)
{
	p.bmap = snow_tga;
	p.lifespan = 200;
	p.event = kill_snow;
	p.size = 4 + random(4);
	set(p,TRANSLUCENT | OVERLAY | MOVE);
	
	p.vel_x = -2 + random(4);
	p.vel_y = -2 + random(4);
	p.vel_z = -10 - random(3);
	
	p.alpha = 40+ random(30);
}

function kill_fire(PARTICLE *p)
{
	p.alpha -= 0.5 * time_step;
	p.size -= 1 * time_step;
	if(p.alpha < 10)
	{
	p.lifespan = 0;	
	}	
}

function fire_part(PARTICLE *p)
{
	p.bmap = fire_bmp;
	p.lifespan = 200;
	p.event = kill_fire;
	p.size = 25 + random(15);
	set(p,TRANSLUCENT | OVERLAY | MOVE);
	
	p.vel_x = -1 + random(2);
	p.vel_y = -1 + random(2);
	p.vel_z = 3 + random(2);
	
	p.alpha = 40+ random(30);
}

function kill_smoke(PARTICLE *p)
{
	p.alpha -= 0.6 * time_step;
	p.size -= 0.4 * time_step;
	if(p.alpha < 10)
	{
	p.lifespan = 0;	
	}	
}

function smoke_part(PARTICLE *p)
{
	p.bmap = smoke_tga;
	p.lifespan = 200;
	p.event = kill_smoke;
	p.size = 15 + random(8);
	set(p,TRANSLUCENT | OVERLAY | MOVE);
	
	p.vel_x = -1 + random(2);
	p.vel_y = -1 + random(2);
	p.vel_z = 3 + random(4);
	
	p.alpha = 10+ random(25);
}

action fire_ball()
{
	var wave;
	
	set(my,INVISIBLE | PASSABLE);
	
	while(my != NULL)
	{
		for(i=0; i<ent_vertices(my); i++)
		{
			vec_for_vertex(temp[0],my,i);
			effect(fireball_part,1,temp[0],nullvector);
		}
		
		my.z = 1584;
		
		my.scale_x = 3+sinv(wave);
		my.scale_y = my.scale_x;
		my.scale_z = my.scale_x;
		
		wave += 10*time_step;
		
		my.pan += 8*time_step;
		my.tilt += 8*time_step;
		wait(1);
	}
}

action player_func()
{
	var distance;
	
	c_updatehull(my,1);
	set(my,POLYGON | INVISIBLE);
	wait(5);
	var lmb;
	
	while(my != NULL)
	{
		if(lmb && mouse_left)
		{
			lmb = 0;
			
			vec_set(temp[0],vector(400,0,0));
			vec_rotate(temp[0],camera.pan);
			vec_add(temp[0],camera.x);
			
			c_trace(camera.x,temp[0],IGNORE_ME | USE_POLYGON | IGNORE_PASSABLE);
			
			if(you != NULL)
			{
				if(you.skill2 == 1)
				{
				if(camera.pan >= -45 && camera.pan <= 45){temp[0] = 128;temp[1] = 0;}
				if(camera.pan >= 45 && camera.pan <= 135){temp[0] = 0;temp[1] = 128;}
				if(camera.pan >= 135 && camera.pan <= 225){temp[0] = -128;temp[1] = 0;}
				if(camera.pan >= 225 && camera.pan <= 315){temp[0] = 0;temp[1] = -128;}
				if(camera.pan >= 315 && camera.pan <= 405){temp[0] = 128;temp[1] = 0;}
				
				c_move(you,nullvector,vector(temp[0],temp[1],0),NULL);
				}
			}
			
		}
		if(!mouse_left){lmb=1;}
		
		
		c_trace(vector(my.x,my.y,my.z+128),vector(my.x,my.y,my.z-400),IGNORE_ME | USE_POLYGON | IGNORE_PASSABLE);
		
		my.z = target.z+28;
		
		c_move(my,vector((key_w-key_s)*5*8*(key_shift+1)*time_step,(key_a-key_d)*5*8*time_step,0),nullvector,GLIDE | IGNORE_PASSABLE);
		
		c_rotate(my,vector(-mouse_force.x * time_step * 5,0,0),GLIDE | IGNORE_PASSABLE);
		camera.tilt += mouse_force.y;
		camera.tilt = clamp(camera.tilt,-65,65);
		
		vec_set(camera.x,my.x);camera.z += 128;
		
		if(my.pan > 360){my.pan -= 360;}
		if(my.pan < 0){my.pan += 360;}
		
		camera.pan = my.pan;
		wait(1);
	}
}

action box()
{
	set(my,SHADOW);
	my.skill2 = 1;
	my.z += 0.1;
}

action water()
{
	set(my,PASSABLE | TRANSLUCENT);
	while(my != NULL)
	{
		if(my.skill4 == 0)
		{
			if(waterfall_group == 1){my.u += 1*time_step;}
			else{my.u += 0.1*time_step;}
		}
		
		if(my.skill4 == 1)
		{
			if(waterfall_group2 == 1){my.u += 1*time_step;}
			else{my.u += 0.1*time_step;}
		}
		wait(1);
	}
}

action fire()
{
	set(my, PASSABLE | TRANSLUCENT);
	
	my.lightrange = 100;
	set(my,LIGHT | UNLIT);
	vec_set(my.blue,vector(50,50,200));
	
	ent_playloop (my,sound3,300);
	
	while(my != NULL)
	{
		temp[0] = my.x -2+random(4);
		temp[1] = my.y -2+random(4);
		temp[2] = my.z;
		effect(fire_part,1,temp[0],nullvector);
		
		temp[2] += 100;
		effect(smoke_part,1,temp[0],nullvector);
		
		my.lightrange = 80 + random(40);
		wait(1);
	}
}

action door()
{
	set(my,SHADOW);
	while(my != NULL)
	{
		if(door_trigger == 1)
		{
			if(my.pan < 90){my.pan += 1*time_step;}
			else{my.pan=90;}
		}
		if(door_trigger == 0)
		{
			if(my.pan > 0){my.pan -= 1*time_step;}
			else{my.pan=0;}
		}
		wait(1);
	}
}

action trigger()
{
	while(my != NULL)
	{
		c_trace(vector(my.x,my.y,my.z-10),vector(my.x,my.y,my.z+200),IGNORE_ME | IGNORE_WORLD | IGNORE_PASSABLE);
		if(my.skill3 == 1)
		{
		if(you != NULL)
		{
			if(you.skill2 == 1)
			{
				waterfall_group = 1;
			}
			
		}
		else{waterfall_group = 0;}
		}
		
		if(my.skill3 == 2)
		{
		if(you != NULL)
		{
			if(you.skill2 == 1)
			{
				waterfall_group2 = 1;
			}
			
		}
		else{waterfall_group2 = 0;}
		}
		
		if(my.skill3 == 3)
		{
		if(you != NULL)
		{
			if(you.skill2 == 1)
			{
				door_trigger = 1;
			}
		}
		else{door_trigger = 0;}
		}
		wait(1);
	}
}

action waterfall()
{
	set(my,PASSABLE | TRANSLUCENT);
	
	my.v = random(1000);
	my.scale_x = 0.01;
	
	var sound_handle = 0;
	
	if(my.skill1 == 1){sound_handle = ent_playloop (my,sound2,300);}
	
	while(my != NULL)
	{
		if(my.skill4 == 0)
		{
		if(waterfall_group == 1)
		{
			if(my.scale_x <= 1){my.scale_x += 0.03*time_step;}
			else{my.scale_x = 1;}
		}
		else
		{
			if(my.scale_x >=0.01){my.scale_x -= 0.03*time_step;}
			else{my.scale_x = 0.01;}
		}
		}
		if(my.skill4 == 1)
		{
		if(waterfall_group2 == 1)
		{
			if(my.scale_x <= 1){my.scale_x += 0.03*time_step;}
			else{my.scale_x = 1;}
		}
		else
		{
			if(my.scale_x >=0.01){my.scale_x -= 0.03*time_step;}
			else{my.scale_x = 0.01;}
		}
		}
		my.v -= 14*time_step;
		wait(1);
	}
}

function snow()
{
	while(1)
	{
		
		for(i=0;i<5;i++)
		{
		temp[0] = -1500+random(950);
		temp[1] = -200+random(1200);
		temp[2] = 1950;
		effect(snow_part,1,temp[0],nullvector);
		}
		
		for(i=0;i<5;i++)
		{
		temp[0] = 1500-random(950);
		temp[1] = -200+random(1200);
		temp[2] = 1950;
		effect(snow_part,1,temp[0],nullvector);
		}
		wait(1);
	}
}

function main()
{
	video_mode = 8;
	video_screen = 1;
	fps_max = 60;
	
	wait(1);
	
	draw_begin();
	
	max_particles = 10000;
	
	level_load("level.wmb");
	vec_set(sky_color.blue,vector(0,0,0));
	
	set(camera,UNTOUCHABLE);
	
	you = ent_createlayer("sky_blue+6.tga",SKY | CUBE | VISIBLE,100);
	
	vec_set(you.blue,vector(50,50,50));
	snow();
}